<?php

namespace RotinaEstoque\Controllers\Planning;

use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DataSource\DataSet;
// use \Teknisa\Model\Planejamento\Entities\Cardadia;
// use \Teknisa\Model\Estoque\Entities\Lanctoestoq;
// use \Teknisa\Model\Planejamento\Entities\Retirada;
// use \Teknisa\Model\Planejamento\Entities\Itemreti;
// use \Teknisa\Model\Estoque\Entities\Itlanctoest;
use \Estoque\Entities\Lanctoestoq;
use Teknisa\PebLibs\Services\ValidacoesEstoqueService;

class HomeController {
  protected $crudService;
  protected $validacoesEstoqueService;
  const COD_ERROR_PEBBIAN = 1500;
  
  public function __construct($connection, $environment, $util, $service, $crudService, ValidacoesEstoqueService $validacoesEstoqueService) {
    $this->connection   = $connection;
    $this->environment  = $environment;
    $this->util         = $util;
    $this->service      = $service;
    $this->crudService	= $crudService;
    $this->validacoesEstoqueService = $validacoesEstoqueService;
  }
  
  public function testConnection(Request\Row $request, Response $response) {
      $data = $this->service->testConnection();
      $response->addDataSet(new DataSet('connection', $data));
    }

  public function getInitialData(Request\Row $request, Response $response) {
    $data = array(
      'NRORG'         => $this->environment->getNrOrg(),
      'LOGGED_BRANCH' => $this->environment->getCdFilial()
    );
    $response->addDataSet(new DataSet('initialData', $data));
  }
  
  public function getCdNvProduto(Request\Row $request, Response $response) {
    $data = $this->service->getCdNvProduto();
    $response->addDataSet(new DataSet('cdNvProduto', $data));
  }
  
  public function loadUnitParameters(Request\Row $request, Response $response) {
    $row = $request->getParameters();
    $params = [
      "CDFILIAL" => $row["CDFILIAL"]["CDFILIAL"],
      "NRORG"    => $this->environment->getNrOrg()
    ];
    $data = $this->service->planningWithdrawalData($params);
    $response->addDataSet(new DataSet("params", $data));
  }

  public function planningWithdrawalData(Request\Row $request, Response $response) {
    $selectedBranch = $request->getParameters();
    $CDFILIAL = $selectedBranch["CDFILIAL"]["CDFILIAL"];
    try {
      $params = [
        "CDFILIAL" => $CDFILIAL,
        "NRORG"    => $this->environment->getNrOrg()
      ];
      
      $data = $this->service->planningWithdrawalData($params);
    } catch(Exception $e) {
        throw $e;
    }
    
    $response->addDataSet(new DataSet('planningWithdrawalData', $data)); 
  }
}