<?php
/**
 * Created by PhpStorm.
 * User: rafaelpickbrenne
 * Date: 27/01/14
 * Time: 14:04
 */

namespace Folha\Facade\Relatorios;


class Gerencial {
    /**
     * Verifica se os fields estão corretamente preenchidos de acordo com o relatório selecionado
     * pck 27/01/2013
     */
    public static function verificaFields() {
        switch(tk_get_field_value('REPORT_NAME')) {  //Nome do relatório
            case '':    //Nenhum relatório selecionado
                tk_abort('Nenhum relatório selecionado.');
                break;
            case 'aniversariantes':
                if(tk_get_field_value('MES') == null)
                    tk_abort('É necessário informar o Mês de Aniversário para emitir este relatório');
                break;
            case 'turn_over':
                if(tk_get_field_value('TIPOESTRUTURA') == null)
                    tk_abort('É necessário informar o Tipo de Estrutura para emitir este relatório');
                break;
            case 'funcionarios_demitidos_periodo':
                if(tk_get_field_value('DATAINICIO') == null || tk_get_field_value('DATAFINAL') == null)
                    tk_abort('É necessário informar as Datas de Inicio e Fim para emitir este relatório');
                break;
            case 'estruturas_tipo_hierarquia':
            case 'tomadores':
                if(tk_get_field_value('TIPOESTRUTURA') == null)
                    tk_abort('É necessário informar o Tipo de Estrutura para emitir este relatório');
                break;
            case 'evento_zerado_por_vinculo':
                if(tk_get_field_value('TIPOMOVIMENTO') == null || tk_get_field_value('MODALIDADECAL') == null)
                    tk_abort('É necessário informar o Tipo de Movimento e Modalidade (Cenário) para emitir este relatório');
                break;
            case 'rateio_funcionarios_grade':
                if(tk_get_field_value('DATAINICIO') == null || tk_get_field_value('DATAFINAL') == null || tk_get_field_value('MODALIDADECAL') == null || tk_get_field_value('TIPOMOVIMENTO') == null || tk_get_field_value('GRUPOINCIDE') == null || tk_get_field_value('TIPOESTRUTURA') == null)
                    tk_abort('É necessário informar as Datas de Inicio e Fim, Modalidade de Cálculo (Cenário), Grupo de Incidência, Tipo de Movimento e o Tipo de Estrutura para emitir este relatório');
                break;
            case 'resumo_inss':
                if(tk_get_field_value('MODALIDADECAL') == null || tk_get_field_value('TIPOMOVIMENTO') == null || tk_get_field_value('GRUPOINCIDE') == null)
                    tk_abort('É necessário informar a Modalidade de Cálculo (Cenário), Grupo de Incidência e o Tipo de Movimento para emitir este relatório');
                break;
            //Relatórios que não possuem parâmetros obrigatórios
            case 'alteracao_salarial':
            case 'alteracao_funcional':
            case 'relacao_funcionario_por_sindicato':
            case 'relacao_funcionario_por_estrutura':
            case 'funcionarios_admitidos_periodo':
            case 'assoc_eventos_vinculo_e':
            case 'assoc_estrutura_evento':
            case 'assoc_eventos_vinculo_v':
            case 'relacao_eventos_estrutura_e_vinculo':
            case 'relacao_funcionario_banco':
            case 'relacao_funcionarios_ativos_mes':
            case 'relacao_funcionarios_ativos_mes_por_sindicato':
                break;
            default:
                tk_abort('Este relatório não está integrado');
        }
    }
} 